/**
 * jax form module
 *
 * @link       https://github.com/jaxjs/jax-form
 * @category   jax-form
 * @author     Nick Sagona, III <dev@nolainteractive.com>
 * @copyright  Copyright (c) 2009-2015 NOLA Interactive, LLC. (http://www.nolainteractive.com)
 * @license    http://www.jaxjs.org/license     New BSD License
 * @version    1.0.0a
 */
jax.extend({rules:[],validators:[],formId:null,errorDisplay:null,trace:null,createForm:function(e,t){var n=t!=null&&t.id!=undefined?t.id:"jax-form",r=t!=null&&t.action!=undefined?t.action:"#",i=t!=null&&t.method!=undefined?t.method:"get";this.append("form",{id:n,action:r,method:i});var s=window.jax("#"+n),o=1;for(var u in e)if(e[u].type!=undefined){if(e[u].attribs!=undefined){var a=e[u].attribs;a.name=u,a.id=u}else a={name:u,id:u};if(e[u].label!=undefined){s.append("div",{id:"jax-label-div-"+o,"class":"jax-label-div"});var f=window.jax("#jax-label-div-"+o);f.append("label",{"for":u},e[u].label),o++}s.append("div",{id:"jax-element-div-"+o,"class":"jax-element-div"});var f=window.jax("#jax-element-div-"+o);switch(e[u].type){case"radio":f.appendRadio(e[u].values,a,e[u].marked);break;case"checkbox":a!=null&&(a.name=a.name+"[]"),f.appendCheckbox(e[u].values,a,e[u].marked);break;case"select":a!=null&&a.multiple!=undefined&&(a.name=a.name+"[]"),f.appendSelect(e[u].values,a,e[u].marked,e[u].optionsFile);break;case"input":f.appendInput(a);break;case"textarea":f.appendTextarea(a,e[u].value);break;default:f.append(e[u].type,a,e[u].value)}o++}return window.jax("#"+n)},setRules:function(e,t,n){this.formId=this[0].id!=undefined?this[0].id:null,n!=undefined&&n!=null&&(this.trace=n);if(e!=undefined&&e!=null){this.rules=e;if(t!=null&&t||t==null){var r=this;this.submit(function(){return r.validate()})}}return this},setErrorDisplay:function(e){return this.errorDisplay=e!=null&&e.color!=undefined?e:null,this},validate:function(){this.validators=[];var animateParams=[];this.parseElements();var trackErrors=[],errors={},htmlError=!1;for(var i=0;i<this.validators.length;i++){var error=this.isValid(this.validators[i]);if(this.validators[i][0]=="radio")var fo=eval("this[0].elements['"+this.validators[i][1]+"'][0]");else if(this.validators[i][0]=="checkbox"||this.validators[i][0]=="select-multiple")var fo=eval("this[0].elements['"+this.validators[i][1]+"'][0]");else var fo=eval("this[0].elements['"+this.validators[i][1]+"']");var foChildren=fo.parentNode.childNodes,parentNode=null;fo.parentNode!=null?parentNode=fo.parentNode:parentNode=this.parent();if(error!=null){fo.focus(),trackErrors.indexOf(this.validators[i][1])==-1&&(trackErrors.push(this.validators[i][1]),errors[this.validators[i][1]]=error),this.validators[i][0].indexOf("select")==-1&&fo.select();if(this.errorDisplay==null)return alert(error),!1;parentNode!=null&&foChildren[foChildren.length-1]!=undefined&&foChildren[foChildren.length-1].nodeName!="SPAN"&&(this.errorDisplay.bgColor!=undefined&&this.errorDisplay.orgColor!=undefined?(animateParams.push([parentNode,[["blendBgColor",{c1:this.errorDisplay.orgColor,c2:this.errorDisplay.bgColor}]]]),window.jax(parentNode).append("span",{"class":"jax-form-error",style:"color: "+this.errorDisplay.orgColor+"; font-weight: bold;"},error),animateParams.push([parentNode.childNodes[parentNode.childNodes.length-1],[["blendColor",{c1:this.errorDisplay.orgColor,c2:this.errorDisplay.color}]]])):this.errorDisplay.bgColor!=undefined?(window.jax(parentNode).append("span",{"class":"jax-form-error",style:"color: "+this.errorDisplay.color+"; font-weight: bold;"},error),window.jax(parentNode).css("background-color",this.errorDisplay.bgColor)):window.jax(parentNode).append("span",{"class":"jax-form-error",style:"color: "+this.errorDisplay.color+"; font-weight: bold;"},error)),htmlError=!0}else trackErrors.indexOf(this.validators[i][1])==-1&&foChildren[foChildren.length-1]!=undefined&&foChildren[foChildren.length-1].nodeName=="SPAN"&&(parentNode!=null&&window.jax(parentNode).css("background","transparent"),foChildren[foChildren.length-1]!=undefined&&window.jax(foChildren[foChildren.length-1]).remove())}this.trace!=null&&this.trace.apply(undefined,[this[0],errors]);if(trackErrors.length>0){var elem=trackErrors[0].indexOf("[")!=-1?trackErrors[0].substring(0,trackErrors[0].indexOf("[")):trackErrors[0];if(window.jax("#"+elem)[0]!=undefined)window.jax("#"+elem)[0].focus();else{var elemObj=eval("this[0]."+elem);elemObj!=null&&elemObj.focus()}}if(animateParams.length>0){var tween=this.errorDisplay.tween!=undefined?this.errorDisplay.tween:15,speed=this.errorDisplay.speed!=undefined?this.errorDisplay.speed:30,easingX=null,easingY=null;if(this.errorDisplay.easing!=undefined)var easingX=this.errorDisplay.easing,easingY=this.errorDisplay.easing;else if(this.errorDisplay.easingX!=undefined&&this.errorDisplay.easingY!=undefined)var easingX=this.errorDisplay.easingX,easingY=this.errorDisplay.easingY;window._test=animateParams,window.jax().animate(animateParams,{tween:tween,speed:speed,easingX:easingX,easingY:easingY})}return!htmlError},parseElements:function(){if(this.rules!=null)for(var fieldName in this.rules){var obj=eval("this[0].elements['"+fieldName+"']");if(obj==undefined)var fldName=fieldName.indexOf("[")!=-1?fieldName.substring(0,fieldName.indexOf("[")):fieldName+"[]",obj=eval("this[0].elements['"+fldName+"']");obj.nodeType==undefined&&(obj=obj[0]);var elemName=fieldName.indexOf("[")!=-1?fieldName.substring(0,fieldName.indexOf("[")):fieldName;elemName=elemName.replace(/_/g," ");for(var val in this.rules[fieldName]){var v=this.rules[fieldName][val];val=val.toLowerCase();var condVal=null,customMsg=null;val=="required"?(val="notempty",customMsg=v.constructor==String?v:"The "+elemName+" field is required."):v.constructor==Object?(v.value!=undefined&&(condVal=v.value),v.message!=undefined&&(customMsg=v.message)):v.constructor==String&&(customMsg=v),this.validators.push([obj.type,obj.name,obj.value,val,condVal,customMsg])}}},isValid:function(elem){var msg=null,elemName=elem[1].indexOf("[")!=-1?elem[1].substring(0,elem[1].indexOf("[")):elem[1];elemName=elemName.replace(/_/g," ");switch(elem[3]){case"alphanum":elem[2].match(/^\w+$/)||(msg=elem[5]!=null?elem[5]:"The "+elemName+" field is not alphanumeric.");break;case"alpha":elem[2].match(/^[a-zA-Z]+$/)||(msg=elem[5]!=null?elem[5]:"The "+elemName+" field must contain only characters of the alphabet.");break;case"between":var numAry=elem[4].split("|");if(parseInt(elem[2])<=parseInt(numAry[0])||parseInt(elem[2])>=parseInt(numAry[1]))msg=elem[5]!=null?elem[5]:"The "+elemName+" field is not between "+numAry[0]+" and "+numAry[1]+".";break;case"email":elem[2].match(/[a-zA-Z0-9\.\-\_+%]+@[a-zA-Z0-9\-\_\.]+\.[a-zA-Z]{2,4}/)||(msg=elem[5]!=null?elem[5]:"The address in the "+elemName+" field is not a valid email.");break;case"equal":elem[2]!=elem[4]&&(msg=elem[5]!=null?elem[5]:"The "+elemName+" field does not equal "+elem[4]+".");break;case"excluded":elem[4].indexOf(elem[2])!=-1&&(msg=elem[5]!=null?elem[5]:"The value "+elem[4]+" must be excluded from the "+elemName+" field.");break;case"greaterthan":parseInt(elem[2])<=parseInt(elem[4])&&(msg=elem[5]!=null?elem[5]:"The "+elemName+" field is not greater than "+elem[4]+".");break;case"included":elem[4].indexOf(elem[2])==-1&&(msg=elem[5]!=null?elem[5]:"The value "+elem[4]+" must be included from the "+elemName+" field.");break;case"length":parseInt(elem[2].length)!=parseInt(elem[4])&&(msg=elem[5]!=null?elem[5]:"The length of the "+elemName+" field does not equal "+elem[4]+".");break;case"lengthbet":var numAry=elem[4].split("|");if(parseInt(elem[2].length)<=parseInt(numAry[0])||parseInt(elem[2].length)>=parseInt(numAry[1]))msg=elem[5]!=null?elem[5]:"The "+elemName+" field is not between "+numAry[0]+" and "+numAry[1]+".";break;case"lengthgt":parseInt(elem[2].length)<=parseInt(elem[4])&&(msg=elem[5]!=null?elem[5]:"The length of the "+elemName+" field is not greater than "+elem[4]+".");break;case"lengthlt":parseInt(elem[2].length)>=parseInt(elem[4])&&(msg=elem[5]!=null?elem[5]:"The length of the "+elemName+" field is not less than "+elem[4]+".");break;case"lessthan":parseInt(elem[2])>=parseInt(elem[4])&&(msg=elem[5]!=null?elem[5]:"The "+elemName+" field is not less than "+elem[4]+".");break;case"notempty":if(elem[0]=="radio"){var counter=0;for(i=0;i<this[0].elements.length;i++)this[0].elements[i].name==elem[1]&&this[0].elements[i].checked&&counter++;if(counter==0){var elemName=elem[1].indexOf("[")!=-1?elem[1].substring(0,elem[1].indexOf("[")):elem[1];msg=elem[5]!=null?elem[5]:"The "+elemName.replace(/_/g," ")+" field must be checked."}}else if(elem[0]=="checkbox"){var counter=0;for(i=0;i<this[0].elements.length;i++)this[0].elements[i].name.indexOf(elem[1])!=-1&&this[0].elements[i].checked&&counter++;if(counter==0){var elemName=elem[1].indexOf("[")!=-1?elem[1].substring(0,elem[1].indexOf("[")):elem[1];msg=elem[5]!=null?elem[5]:"The "+elemName.replace(/_/g," ")+" field must be checked."}}else if(elem[0]=="select-multiple"){var counter=0;for(i=0;i<this[0].elements.length;i++)if(this[0].elements[i].name.indexOf(elem[1])!=-1)for(j=0;j<this[0].elements[i].options.length;j++)this[0].elements[i].options[j].selected&&counter++;counter==0&&(msg=elem[5]!=null?elem[5]:"The "+elemName+" field must be checked.")}else elem[2].length<1&&(msg=elem[5]!=null?elem[5]:"The "+elemName+" field is empty.");break;case"notequal":elem[2]==elem[4]&&(msg=elem[5]!=null?elem[5]:"The "+elemName+" field cannot equal "+elem[4]+".");break;case"num":isNaN(elem[2])&&(msg=elem[5]!=null?elem[5]:"The "+elemName+" field is not a number.");break;case"regex":var regex=eval(elem[4]);elem[2].match(regex)||(msg=elem[5]!=null?elem[5]:"The "+elemName+" field is not in the correct format.");break;default:msg=null}return msg},getLength:function(e){if(e.value.length==e.maxLength){var t=e.tabIndex;t<this[0].length&&this[0].elements[t].focus()}},checkValidate:function(e,t,n){var r=this[0].elements,i=0;for(var s=0;s<r.length;s++)r[s].type=="checkbox"&&r[s].checked&&i++;return e!=null&&i==0?(n==null&&(n="Please select at least one "+e+"."),alert(n),!1):t!=null?(n==null&&(n="This action cannot be undone. Are you sure?"),confirm(n)):!0},checkAll:function(e,t){t!=null?t.constructor!=Array&&(t=[t]):t=[];var n=this[0].elements;if(e==null){for(var r=0;r<n.length;r++)if(n[r].type=="checkbox"&&t.indexOf(n[r].value)==-1)n[r].checked||(n[r].checked=!0);else if(n[r].nodeName=="SELECT"&&n[r].multiple){opts=n[r].getElementsByTagName("option");for(j=0;j<opts.length;j++)!opts[j].selected&&t.indexOf(opts[j].value)==-1&&(opts[j].selected=!0)}}else for(var r=0;r<n.length;r++)if(n[r].id.indexOf(e)!=-1||n[r].name.indexOf(e)!=-1)if(n[r].type=="checkbox"&&t.indexOf(n[r].value)==-1)n[r].checked||(n[r].checked=!0);else if(n[r].nodeName=="SELECT"&&n[r].multiple){opts=n[r].getElementsByTagName("option");for(j=0;j<opts.length;j++)!opts[j].selected&&t.indexOf(opts[j].value)==-1&&(opts[j].selected=!0)}},uncheckAll:function(e,t){t!=null?t.constructor!=Array&&(t=[t]):t=[];var n=this[0].elements;if(e==null){for(var r=0;r<n.length;r++)if(n[r].type=="checkbox"&&t.indexOf(n[r].value)==-1)n[r].checked&&(n[r].checked=!1);else if(n[r].nodeName=="SELECT"&&n[r].multiple){opts=n[r].getElementsByTagName("option");for(j=0;j<opts.length;j++)opts[j].selected&&t.indexOf(opts[j].value)==-1&&(opts[j].selected=!1)}}else for(var r=0;r<n.length;r++)if(n[r].id.indexOf(e)!=-1||n[r].name.indexOf(e)!=-1)if(n[r].type=="checkbox"&&t.indexOf(n[r].value)==-1)n[r].checked&&(n[r].checked=!1);else if(n[r].nodeName=="SELECT"&&n[r].multiple){opts=n[r].getElementsByTagName("option");for(j=0;j<opts.length;j++)opts[j].selected&&t.indexOf(opts[j].value)==-1&&(opts[j].selected=!1)}},checkInverse:function(e,t){t!=null?t.constructor!=Array&&(t=[t]):t=[];var n=this[0].elements;if(e==null){for(var r=0;r<n.length;r++)if(n[r].type=="checkbox"&&t.indexOf(n[r].value)==-1)n[r].checked=n[r].checked?!1:!0;else if(n[r].nodeName=="SELECT"&&n[r].multiple){opts=n[r].getElementsByTagName("option");for(j=0;j<opts.length;j++)t.indexOf(opts[j].value)==-1&&(opts[j].selected=opts[j].selected?!1:!0)}}else for(var r=0;r<n.length;r++)if(n[r].id.indexOf(e)!=-1||n[r].name.indexOf(e)!=-1)if(n[r].type=="checkbox"&&t.indexOf(n[r].value)==-1)n[r].checked=n[r].checked?!1:!0;else if(n[r].nodeName=="SELECT"&&n[r].multiple){opts=n[r].getElementsByTagName("option");for(j=0;j<opts.length;j++)t.indexOf(opts[j].value)==-1&&(opts[j].selected=opts[j].selected?!1:!0)}}});